%global git_hash 3136abc
%global folder_hash 86e329e

Name:       npm
Version:    1.0.106
Release:    1%{?dist}
Summary:    Node.js Package Manager
License:    MIT
URL:        http://npmjs.org/
# download from https://github.com/isaacs/npm/tarball/v%%{version}
Source0:    isaacs-npm-v%{version}-0-g%{git_hash}.tar.gz
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:  noarch

BuildRequires:  nodejs-devel nodejs-compat-symlinks
BuildRequires:  nodejs-abbrev nodejs-ini nodejs-minimatch nodejs-graceful-fs
BuildRequires:  nodejs-nopt nodejs-proto-list nodejs-rimraf nodejs-request
BuildRequires:  nodejs-slide-flow-control nodejs-uuid nodejs-which
BuildRequires:  nodejs-ronn nodejs-semver

Requires:   nodejs nodejs-devel nodejs-waf gcc gcc-c++
Requires:   nodejs-abbrev nodejs-ini nodejs-minimatch
Requires:   nodejs-nopt nodejs-proto-list nodejs-rimraf
Requires:   nodejs-slide-flow-control nodejs-uuid nodejs-which

Requires:	nodejs-graceful-fs >= 1.0.2-0.1
Requires:   nodejs-request >= 2.2.0
Requires:   nodejs-semver >= 1.0.11

# disable downloading ronn via NPM
Patch1:     npm-ronn.patch

%description
npm is a package manager for node.js. You can use it to install and publish your
node programs. It manages dependencies and does other cool stuff.

%prep
%setup -q -n isaacs-npm-%{folder_hash}
%patch1

%nodejs_fixshebang bin/npm-cli.js cli.js

# fix some permissions
chmod -x bin/read-package-json.js
chmod -x bin/npm-get-uid-gid.js
chmod +x lib/utils/completion.sh

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{nodejs_libdir}/npm/
cp -pr bin lib cli.js package.json %{buildroot}%{nodejs_libdir}/npm/

ln -s ../../../share/doc/%{name}-%{version}/doc %{buildroot}%{nodejs_libdir}/npm/doc

mkdir -p %{buildroot}%{_bindir}
ln -s ../lib/nodejs/npm/bin/npm-cli.js %{buildroot}%{_bindir}/npm

# ghosted global config files
mkdir -p %{buildroot}%{_sysconfdir}
touch %{buildroot}%{_sysconfdir}/npmrc
touch %{buildroot}%{_sysconfdir}/npmignore

# link node_modules to the right folder so global installation works
ln -s %{nodejs_libdir} %{buildroot}%{_libdir}/../lib/node_modules

# generate man pages
make doc

# install to npm directory (ungzipped)
cp -pr man %{buildroot}%{nodejs_libdir}/npm/

# prefix all manpages with "npm-"
pushd man
for dir in *; do
    pushd $dir
    for page in *; do
        if [[ $page != npm* ]]; then
            mv $page npm-$page
        fi
    done
    popd
done
popd

# install to mandir
mkdir -p %{buildroot}%{_datadir}
cp -pr man %{buildroot}%{_datadir}/

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%dir %{nodejs_libdir}/npm
%{nodejs_libdir}/npm/bin
%{nodejs_libdir}/npm/lib
%{nodejs_libdir}/npm/doc
%{nodejs_libdir}/npm/man
%{nodejs_libdir}/npm/cli.js
%{nodejs_libdir}/npm/package.json
%{_libdir}/../lib/node_modules
%ghost %{_sysconfdir}/npmrc
%ghost %{_sysconfdir}/npmignore
%{_bindir}/npm
%{_mandir}/*
%doc AUTHORS CHANGES doc html README.md LICENSE

%changelog
* Tue Nov 17 2011 T.C. Hollingsworth <tchollingsworth@gmail.com> - 1.0.106-1
- new upstream release 1.0.106
- ship manpages again

* Thu Nov 10 2011 T.C. Hollingsworth <tchollingsworth@gmail.com> - 1.0.105-1
- new upstream release 1.0.105
- use relative symlinks instead of absolute
- fixes /usr/bin/npm symlink on i686

* Mon Nov 07 2011 T.C. Hollingsworth <tchollingsworth@gmail.com> - 1.0.104-1
- new upstream release 1.0.104
- adds node 0.6 support

* Wed Oct 26 2011 T.C. Hollingsworth <tchollingsworth@gmail.com> - 1.0.101-2
- missing Requires on nodejs-request
- Require compilers too so native modules build properly

* Tue Oct 25 2011 T.C. Hollingsworth <tchollingsworth@gmail.com> - 1.0.101-1
- new upstream release
- use symlink /usr/lib/node_modules -> /usr/lib/nodejs instead of patching

* Thu Aug 25 2011 T.C. Hollingsworth <tchollingsworth@gmail.com> - 1.0.26-2
- rebuilt with fixed nodejs_fixshebang macro from nodejs-devel-0.4.11-3

* Tue Aug 23 2011 T.C. Hollingsworth <tchollingsworth@gmail.com> - 1.0.26-1
- initial package
